"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertTSTypeElements = void 0;
const t = __importStar(require("@babel/types"));
const convertTSType_1 = require("./convertTSType");
const convertFunctionTypeAnnotation_1 = require("./convertFunctionTypeAnnotation");
const convertKey_1 = require("./convertKey");
function convertTSTypeElements(elements) {
    const properties = [];
    const indexers = [];
    const callProperties = [];
    const internalSlots = [];
    for (const member of elements) {
        if (t.isTSCallSignatureDeclaration(member)) {
            const { typeParams, parameters, rest, returnType, } = convertFunctionTypeAnnotation_1.convertFunctionTypeAnnotation(member);
            callProperties.push(t.objectTypeCallProperty(t.functionTypeAnnotation(typeParams, parameters, rest, returnType ? returnType : t.anyTypeAnnotation())));
        }
        if (t.isTSConstructSignatureDeclaration(member)) {
            throw new Error('not implemented');
        }
        if (t.isTSPropertySignature(member)) {
            const key = convertKey_1.convertKey(member.key);
            const prop = t.objectTypeProperty(key, convertTSType_1.convertTSType(member.typeAnnotation.typeAnnotation));
            if (member.readonly) {
                prop.variance = t.variance('plus');
            }
            if (member.optional) {
                prop.optional = true;
            }
            properties.push(prop);
        }
        if (t.isTSMethodSignature(member)) {
            const key = convertKey_1.convertKey(member.key);
            const { typeParams, parameters, rest, returnType, } = convertFunctionTypeAnnotation_1.convertFunctionTypeAnnotation(member);
            const prop = t.objectTypeProperty(key, t.functionTypeAnnotation(typeParams, parameters, rest, returnType ? returnType : t.anyTypeAnnotation()));
            // @ts-ignore todo: @babel-types
            prop.method = true;
            if (member.optional) {
                prop.optional = true;
            }
            properties.push(prop);
        }
        if (t.isTSIndexSignature(member)) {
            const indexer = t.objectTypeIndexer(t.identifier(member.parameters[0].name), convertTSType_1.convertTSType(member.parameters[0].typeAnnotation
                .typeAnnotation), convertTSType_1.convertTSType(member.typeAnnotation.typeAnnotation));
            if (member.readonly) {
                indexer.variance = t.variance('plus');
            }
            indexers.push(indexer);
        }
    }
    return {
        properties,
        indexers,
        callProperties,
        internalSlots,
    };
}
exports.convertTSTypeElements = convertTSTypeElements;
//# sourceMappingURL=convertTSTypeElements.js.map