"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExportNamedDeclaration = void 0;
const t = __importStar(require("@babel/types"));
const convertFunctionTypeAnnotation_1 = require("../converters/convertFunctionTypeAnnotation");
const replaceWith_1 = require("../utils/replaceWith");
const convertClassTypeDeclaration_1 = require("../converters/convertClassTypeDeclaration");
function ExportNamedDeclaration(path) {
    const srcDeclaration = path.node.declaration;
    if (t.isVariableDeclaration(srcDeclaration) && srcDeclaration.declare) {
        if (srcDeclaration.declarations.length !== 1) {
            throw new Error('not implemented');
        }
        if (!t.isIdentifier(srcDeclaration.declarations[0].id)) {
            throw new Error('not implemented');
        }
        path.replaceWith(t.declareExportDeclaration(t.declareVariable(srcDeclaration.declarations[0].id)));
    }
    else if (t.isTSDeclareFunction(srcDeclaration)) {
        // todo: copypaste from ExportDefaultDeclaration.ts
        const { typeParams, parameters, rest, returnType, } = convertFunctionTypeAnnotation_1.convertFunctionTypeAnnotation(srcDeclaration);
        const id = t.identifier(srcDeclaration.id.name);
        id.typeAnnotation = t.typeAnnotation(t.functionTypeAnnotation(typeParams, parameters, rest, returnType ? returnType : t.anyTypeAnnotation()));
        const declaration = t.declareFunction(id);
        const replacement = t.declareExportDeclaration(declaration);
        replaceWith_1.replaceWith(path, replacement);
        // todo: remove typecast to any
    }
    else if (t.isClassDeclaration(srcDeclaration)) {
        const replacement = t.declareExportDeclaration(convertClassTypeDeclaration_1.convertClassTypeDeclaration(srcDeclaration));
        replaceWith_1.replaceWith(path, replacement);
    }
    else if (srcDeclaration && srcDeclaration.declare) {
        srcDeclaration.declare = false;
    }
}
exports.ExportNamedDeclaration = ExportNamedDeclaration;
//# sourceMappingURL=ExportNamedDeclaration.js.map